%bcond_with perl_Module_Implementation_enables_extra_test
%bcond_with perl_Module_Implementation_enables_optional_test

Summary:	Loads one of several alternate underlying implementations for a module
Name:		perl-Module-Implementation
Version:	0.09
Release:	6%{?dist}
License:	Artistic 2.0
URL:		https://metacpan.org/dist/Module-Implementation
Source0:	https://cpan.metacpan.org/authors/id/D/DR/DROLSKY/Module-Implementation-%{version}.tar.gz

BuildRequires:	coreutils findutils make perl-interpreter perl-generators perl(ExtUtils::MakeMaker)
BuildRequires:	perl(Carp) perl(strict) perl(warnings) perl(Try::Tiny)
BuildRequires:	perl(Module::Runtime) >= 0.012
# Test
BuildRequires:	perl(blib) perl(File::Spec) perl(IO::Handle) perl(IPC::Open3) perl(lib) perl(Test::Requires)
BuildRequires:	perl(Test::Fatal) >= 0.006
BuildRequires:	perl(Test::More) >= 0.96

%if %{with perl_Module_Implementation_enables_optional_test}
BuildRequires:	perl(CPAN::Meta) >= 2.120900
%if ! 0%{?perl_bootstrap}
BuildRequires:	perl(Test::CleanNamespaces)
%endif
BuildRequires:  perl(Test::Taint)
%endif
%if %{with perl_Module_Implementation_enables_extra_test}
%if ! %{defined perl_bootstrap}
BuildRequires:	perl(Pod::Coverage::TrustPod) perl(Test::EOL) perl(Test::NoTabs)
BuildRequires:	perl(Test::CPAN::Changes) >= 0.19
BuildRequires:	perl(Test::Pod::Coverage) >= 1.08
BuildRequires:	perl(Test::Pod) >= 1.41
BuildRequires:	
%endif
%endif

Requires:		perl(Carp)
BuildArch:		noarch

%description
This module abstracts out the process of choosing one of several underlying
implementations for a module. This can be used to provide XS and pure Perl
implementations of a module, or it could be used to load an implementation
for a given OS or any other case of needing to provide multiple
implementations.

This module is only useful when you know all the implementations ahead of
time. If you want to load arbitrary implementations then you probably want
something like a plugin system, not this module.

%prep
%autosetup -n Module-Implementation-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%make_build

%install
%make_install
%{_fixperms} -c %{buildroot}

%check
%if 0%{?perl_bootstrap}
make test
%else
%if %{with perl_Module_Implementation_enables_extra_test}
make test RELEASE_TESTING=1
%else
make test
%endif
%endif

%files
%license LICENSE
%doc Changes README.md
%{perl_vendorlib}/Module/
%{_mandir}/man3/Module::Implementation.3*

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.09-6
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Aug 16 2023 Xiaojie Chen <jackxjchen@tencent.com> - 0.09-5
- Remove perl(:MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.09-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.09-3
- Rebuilt for OpenCloudOS Stream 23

* Thu Feb 16 2023 rockerzhu <rockerzhu@tencent.com> - 0.09-2
- Control buildrequires

* Mon May 9 2022 Xiaojie Chen <jackxjchen@tencent.com> - 0.09-1
- Initial build
